/*******************************************************************************
 * FoxPawn_DeployableTurret generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxPawn_DeployableTurret extends FoxGame_AITurretPawn
    native
    config(Pawn)
    hidecategories(Navigation);

var protected class<FoxWeapon> TurretWeaponClass;
var name DeployingAnimName;
var name DeathAnimName;
var name FiringAnimName;
var float AnimRate;
var float AnimBlendInTime;
var float AnimBlendOutTime;
var transient BodyStance OurBodyStance;
var() MaterialInstanceConstant NormalMIC;
var private export editinline ParticleSystemComponent PSComp_LaserEye;
var private ParticleSystem DeathEffectPS_Secondary;
var private const array<name> DeathEffectPSNames_Secondary;
var private const bool bDeathEffectPSIsSocket_Secondary;
var private const float ExplosionTime_First;
var private const float ExplosionTime_Second;
var private const float DestroyTurretTime;

simulated function PostBeginPlay()
{
    local AnimNodeSlot DeployAnimSlot;
    local float LengthOfAnim;

    super(FoxPawn_DeployableBase).PostBeginPlay();
    // End:0x127
    if(Role == ROLE_Authority)
    {
        AimOffsetInterpSpeed = 4.0;
        AddInventory(TurretWeaponClass, true);
        MyFoxWeapon.ImageIconRef = "UI_Icons.Depot.t_turret";
        MyFoxWeapon.bInfiniteSpareAmmo = true;
        MyFoxWeapon.MagSize = 75.0;
        MyFoxWeapon.Mesh.SetHidden(true);
        MyFoxWeapon.SetModsVisible(false, false);
        SetTimer(5.0, true, 'OnRecordWeaponUseTime');
    }
    SetSlotAttachment(TurretWeaponClass.default.WeaponSlot, TurretWeaponClass.default.WeaponAttachmentClass);
    Mesh.AttachComponentToSocket(PSComp_LaserEye, 'S_Camera');
    DeployAnimSlot = AnimNodeSlot(Mesh.FindAnimNode('Custom_FullBody'));
    // End:0x24C
    if(DeployAnimSlot != none)
    {
        LengthOfAnim = DeployAnimSlot.PlayCustomAnim(DeployingAnimName, AnimRate, 0.0, AnimBlendOutTime, false, true);
        SetTimer(LengthOfAnim, false, 'DeployedFinished');
    }
    //return;    
}

function OnRecordWeaponUseTime()
{
    local FoxOnlineStatsWriteWeaponUse TurretTimeUse;

    // End:0xA9
    if((!IsInjured() && IsAliveAndWell()) && OwningPlayerPRI != none)
    {
        TurretTimeUse = OwningPlayerPRI.PlayerStatsManager.FindWeaponStatsByClass(TurretWeaponClass);
        // End:0xA9
        if(TurretTimeUse != none)
        {
            TurretTimeUse.AddTimeUsed(5.0);
        }
    }
    //return;    
}

simulated function DeployedFinished()
{
    ClearTimer('DeployedFinished');
    StartLaserFX();
    //return;    
}

simulated event bool CanDoSpecialMove(const FoxTypes.ESpecialMove AMove)
{
    // End:0x4A
    if(IsDoingASpecialMove() && !SpecialMoves[SpecialMove].RequestEndSpecialMove(AMove))
    {
        return false;
    }
    // End:0x79
    if((AMove == 2) || AMove == 6)
    {
        return false;
    }
    // End:0x7B
    else
    {
        return true;
    }
    //return ReturnValue;    
}

simulated function bool StartLaserFX()
{
    // End:0x62
    if(((OwningPlayerPRI == none) || WorldInfo.GRI == none) || WorldInfo.NetMode == NM_DedicatedServer)
    {
        return false;
    }
    PSComp_LaserEye.DeactivateSystem();
    PSComp_LaserEye.SetColorParameter('Color', ((IsFriendlyToLocalPlayer()) ? class'FoxTeamInfo'.default.FriendlyTeamColor : class'FoxTeamInfo'.default.EnemyTeamColor));
    PSComp_LaserEye.ActivateSystem();
    return true;
    //return ReturnValue;    
}

simulated function OnChangeTeam()
{
    KillLaserFX();
    StartLaserFX();
    //return;    
}

simulated event Destroyed()
{
    KillLaserFX();
    super(FoxPawn).Destroyed();
    //return;    
}

function AddHealDamageStat(FoxOnlineStatsWriteWeaponUse WeaponUsageStats, int HealAmount)
{
    // End:0x5F
    if(WeaponUsageStats != none)
    {
        WeaponUsageStats.IncrementRepairAmount(HealAmount);
        WeaponUsageStats.IncrementTurretRepairAmount(HealAmount);
    }
    //return;    
}

function bool Died(Controller Killer, class<DamageType> DamageType, Vector HitLocation)
{
    // End:0x112
    if((((FoxPC(Killer) != none) && FoxPRI(FoxPC(Killer).PlayerReplicationInfo) != none) && FoxPRI(FoxPC(Killer).PlayerReplicationInfo).WeaponUsageStats != none) && !OnSameTeamAsController(Killer))
    {
        FoxPRI(FoxPC(Killer).PlayerReplicationInfo).WeaponUsageStats.IncrementDestroyedTurret();
    }
    return super(FoxPawn).Died(Killer, DamageType, HitLocation);
    //return ReturnValue;    
}

simulated function KillLaserFX()
{
    // End:0x6D
    if(PSComp_LaserEye != none)
    {
        PSComp_LaserEye.DeactivateSystem();
        PSComp_LaserEye.SetHidden(true);
        PSComp_LaserEye.KillParticlesForced();
    }
    //return;    
}

protected simulated function float PlayDeathAnimation(const class<DamageType> DamageType, const Vector HitLoc)
{
    OurBodyStance.AnimName[0] = DeathAnimName;
    PlayBodyStance(OurBodyStance, AnimRate, AnimBlendInTime, -1.0, false, true);
    return 0.0;
    //return ReturnValue;    
}

protected simulated function PlayDeathAudio(const class<DamageType> DamageType, const Vector HitLoc, const float DeathEffectTime)
{
    super(FoxPawn).PlayDeathAudio(DamageType, HitLoc, DeathEffectTime);
    //return;    
}

protected simulated function PlayDeathFX(const class<DamageType> DamageType, const Vector HitLoc, const float DeathEffectTime)
{
    local int I;

    super(FoxPawn).PlayDeathFX(DamageType, HitLoc, DeathEffectTime);
    // End:0x50
    if(WorldInfo.NetMode == NM_DedicatedServer)
    {
        return;
    }
    SetTimer(ExplosionTime_First, false, 'PlaySecondaryExplosion');
    SetTimer(ExplosionTime_Second, false, 'FinalExplosion');
    SetTimer(DestroyTurretTime, false, 'DestroyTurret');
    // End:0x13A
    if(DeathEffectPS_Secondary != none)
    {
        I = 0;
        J0xAF:
        // End:0x13A [Loop If]
        if(I < DeathEffectPSNames_Secondary.Length)
        {
            WorldInfo.MyEmitterPool.SpawnEmitterMeshAttachment(DeathEffectPS_Secondary, Mesh, DeathEffectPSNames_Secondary[I], bDeathEffectPSIsSocket_Secondary);
            ++ I;
            // [Loop Continue]
            goto J0xAF;
        }
    }
    //return;    
}

simulated function PlaySecondaryExplosion()
{
    Mesh.HideBoneByName(HeadshotPSBoneName, 1);
    //return;    
}

simulated function FinalExplosion()
{
    Mesh.SetHidden(true);
    //return;    
}

simulated function DestroyTurret()
{
    Destroy();
    //return;    
}

function bool ShouldGoToInjured(class<FoxDamageType> DamageType)
{
    return false;
    //return ReturnValue;    
}

simulated function ToggleHRVEffects(const bool bEnabled, const bool bFriendly, const bool bHardSuitHRV)
{
    local int I;
    local PlayerController LocalPC;

    super(FoxPawn).ToggleHRVEffects(bEnabled, bFriendly, bHardSuitHRV);
    LocalPC = GetALocalPlayerController();
    // End:0x93
    if(bEnabled && ((LocalPC == none) || WorldInfo.GRI == none) || OwningPlayerPRI == none)
    {
        return;
    }
    // End:0x1B9
    if(bEnabled && IsAliveAndWell())
    {
        // End:0x13F
        if(OnSameTeamAsController(LocalPC))
        {
            I = 0;
            J0xD0:
            // End:0x13C [Loop If]
            if(I < Mesh.GetNumElements())
            {
                Mesh.SetMaterial(I, FriendlyHVTMaterialInstance);
                ++ I;
                // [Loop Continue]
                goto J0xD0;
            }
        }
        // End:0x1B6
        else
        {
            I = 0;
            J0x14A:
            // End:0x1B6 [Loop If]
            if(I < Mesh.GetNumElements())
            {
                Mesh.SetMaterial(I, EnemyHVTMaterialInstance);
                ++ I;
                // [Loop Continue]
                goto J0x14A;
            }
        }
    }
    // End:0x228
    else
    {
        I = 0;
        J0x1C4:
        // End:0x228 [Loop If]
        if(I < Mesh.GetNumElements())
        {
            Mesh.SetMaterial(I, none);
            ++ I;
            // [Loop Continue]
            goto J0x1C4;
        }
    }
    //return;    
}

simulated event ToggleIREffects(bool bTurnOn)
{
    local int I;

    super(FoxPawn).ToggleIREffects(bTurnOn);
    // End:0xA3
    if(!bTurnOn || !IsAliveAndWell())
    {
        I = 0;
        J0x3F:
        // End:0xA3 [Loop If]
        if(I < Mesh.GetNumElements())
        {
            Mesh.SetMaterial(I, none);
            ++ I;
            // [Loop Continue]
            goto J0x3F;
        }
    }
    //return;    
}

defaultproperties
{
    DeployingAnimName=Deployed_A
    DeathAnimName=Death_A
    AnimRate=1.0
    AnimBlendInTime=0.10
    AnimBlendOutTime=0.150
    begin object name=PS_LaserEye0 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxPawn_DeployableTurret.PS_LaserEye0'
    PSComp_LaserEye=PS_LaserEye0
    ExplosionTime_First=1.0
    ExplosionTime_Second=3.0
    DestroyTurretTime=5.0
    bIsMachine=true
    EnemyHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_DeployableTurret.EnemyHVTMaterialInstance0'
    JamEnemyHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_DeployableTurret.JamEnemyHVTMaterialInstance0'
    FriendlyHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_DeployableTurret.FriendlyHVTMaterialInstance0'
    NuetralHVTMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_DeployableTurret.NuetralHVTMaterialInstance0'
    EnemyIRMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_DeployableTurret.EnemyIRMaterialInstance0'
    FriendlyIRMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_DeployableTurret.FriendlyIRMaterialInstance0'
    NuetralIRMaterialInstance=MaterialInstanceConstant'Default__FoxPawn_DeployableTurret.NuetralIRMaterialInstance0'
    LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxPawn_DeployableTurret.TPLightEnvironment'
    TakeDamageCameraShake=CameraShake'Default__FoxPawn_DeployableTurret.Shake0'
    HealthRechargeMaxPercent=0.0
    FlameEffectsPSBoneName=Gun
    FlameImpactBoneName=Gun
    HeadshotPSBoneName=Gun
    DamageProfiles(0)=(TakeDamageCameraShake=CameraShake'Default__FoxPawn_DeployableTurret.Shake1',DamageAmount=40)
    DamageProfiles(1)=(TakeDamageCameraShake=CameraShake'Default__FoxPawn_DeployableTurret.Shake2',DamageAmount=150)
    DamageProfiles(2)=(TakeDamageCameraShake=CameraShake'Default__FoxPawn_DeployableTurret.Shake3',DamageAmount=1500)
    bReplicateHealthToAll=true
    PeripheralVision=0.650
    begin object name=PawnSkeletalMeshComponent class=SkeletalMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxPawn_DeployableTurret.TPLightEnvironment'
    object end
    // Reference: SkeletalMeshComponent'Default__FoxPawn_DeployableTurret.PawnSkeletalMeshComponent'
    Mesh=PawnSkeletalMeshComponent
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPawn_DeployableTurret.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    Components(0)=none
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPawn_DeployableTurret.CollisionCylinder'
    Components(1)=CollisionCylinder
    Components(2)=none
    Components(3)=DynamicLightEnvironmentComponent'Default__FoxPawn_DeployableTurret.TPLightEnvironment'
    begin object name=PawnSkeletalMeshComponent class=SkeletalMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxPawn_DeployableTurret.TPLightEnvironment'
    object end
    // Reference: SkeletalMeshComponent'Default__FoxPawn_DeployableTurret.PawnSkeletalMeshComponent'
    Components(4)=PawnSkeletalMeshComponent
    Components(5)=DynamicLightEnvironmentComponent'Default__FoxPawn_DeployableTurret.FPLightEnvironmentObj'
    begin object name=PS_LaserEye0 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxPawn_DeployableTurret.PS_LaserEye0'
    Components(6)=PS_LaserEye0
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPawn_DeployableTurret.CollisionCylinder'
    CollisionComponent=CollisionCylinder
    RotationRate=(Pitch=20000,Yaw=2147483647,Roll=20000)
}